﻿Public Class Form1

    Dim willForcedProceed As Boolean = False

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' ウィンドウを中央寄せ
        Dim sW As Integer = SystemInformation.WorkingArea.Width
        Dim sH As Integer = SystemInformation.WorkingArea.Height
        Dim px As New Point((sW - Me.Width) / 2, (sH - Me.Height) / 2)
        Me.Location = px

    End Sub



    '' Windowsを操作するのに必要なメソッド
    Public Enum ExitWindows

        EWX_LOGOFF = &H0
        EWX_SHUTDOWN = &H1
        EWX_REBOOT = &H2
        EWX_POWEROFF = &H8
        EWX_RESTARTAPPS = &H40
        EWX_FORCE = &H4
        EWX_FORCEIFHUNG = &H10

    End Enum

    <System.Runtime.InteropServices.DllImport("user32.dll", SetLastError:=True)> _
    Public Shared Function ExitWindowsEx(ByVal uFlags As ExitWindows, ByVal dwReason As Integer) As DateBoldEventArgs



    End Function

    '' NT（または以降）用メソッド
    <System.Runtime.InteropServices.DllImport("kernel32.dll")> _
    Private Shared Function GetCurrentProcess() As IntPtr



    End Function

    <System.Runtime.InteropServices.DllImport("advapi32.dll", SetLastError:=True)> _
    Shared Function OpenProcessToken(ByVal ProcessHandle As IntPtr, ByVal DesiredAccess As Integer, ByRef TokenHandle As IntPtr) As Boolean



    End Function

    <System.Runtime.InteropServices.DllImport("advapi32.dll", SetLastError:=True, CharSet:=Runtime.InteropServices.CharSet.Auto)> _
    Shared Function LookupPrivilegeValue(ByVal lpSystemName As String, ByVal lpName As String, ByRef lpLuid As Long) As Boolean



    End Function

    <System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, Pack:=1)> _
    Private Structure TOKEN_PRIVILEGES

        Public PrivilegeCount As Integer
        Public Luid As Long
        Public Attributes As Integer

    End Structure

    <System.Runtime.InteropServices.DllImport("advapi32.dll", SetLastError:=True)> _
    Private Shared Function AdjustTokenPrivileges(ByVal TokenHandle As IntPtr, ByVal DisableAllPrivileges As Boolean, ByRef NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Integer, ByVal PreviousState As IntPtr, ByVal ReturnLength As IntPtr) As Boolean



    End Function

    Public Sub AdjustToken()

        Const TOKEN_ADJUST_PRIVILEGES As Integer = &H20
        Const TOKEN_QUERY As Integer = &H8
        Const SE_PRIVILEGE_ENABLED As Integer = &H2
        Const SE_SHUTDOWN_NAME As String = "SeShutdownPrivilege"

        If Environment.OSVersion.Platform <> PlatformID.Win32NT Then Return

        Dim procHandle As IntPtr = GetCurrentProcess()

        ' トークンを取得する
        Dim tokenHandle As IntPtr
        OpenProcessToken(procHandle, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, tokenHandle)

        ' LUIDを取得する
        Dim tp As New TOKEN_PRIVILEGES
        tp.Attributes = SE_PRIVILEGE_ENABLED
        tp.PrivilegeCount = 1
        LookupPrivilegeValue(Nothing, SE_SHUTDOWN_NAME, tp.Luid)

        ' 特権を有効にする
        AdjustTokenPrivileges(tokenHandle, False, tp, 0, IntPtr.Zero, IntPtr.Zero)

    End Sub



    ' Windowsの操作処理を準備する
    Private Sub prepareToExitFromWindows()

        AdjustToken()
        Me.Close()

    End Sub

    ' 処理を強制的に進めるか否かのスイッチ
    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label1.Click

        Static origText = Label1.Text

        If willForcedProceed = False Then

            Label1.Text = "コンピューターの電源を強制的に切る"
            Label1.ForeColor = Color.Red

            willForcedProceed = True

        Else

            Label1.Text = "コンピュータの電源を切る"
            Label1.ForeColor = Color.White

            willForcedProceed = False

        End If

    End Sub

    ' スタンバイ
    Private Sub standingby_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles standingby.Click

        If willForcedProceed = True Then

            Application.SetSuspendState(PowerState.Suspend, True, False)

        Else

            Application.SetSuspendState(PowerState.Suspend, False, False)

        End If

    End Sub

    ' シャットダウン
    Private Sub shutingdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles shutingdown.Click

        If willForcedProceed = True Then

            If MsgBox("Windowsを強制的にシャットダウンします。開かれている全てのプログラムは閉じられ、保存されていないデータは失われます。続行しますか？", MsgBoxStyle.YesNo Or MsgBoxStyle.Question, "") = MsgBoxResult.Yes Then

                prepareToExitFromWindows()
                ExitWindowsEx(ExitWindows.EWX_POWEROFF Or ExitWindows.EWX_POWEROFF, 0)

            Else

                Exit Sub

            End If

        Else

            prepareToExitFromWindows()
            ExitWindowsEx(ExitWindows.EWX_SHUTDOWN, 0)

        End If

    End Sub

    ' 再起動
    Private Sub restarting_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles restarting.Click

        If willForcedProceed = True Then

            If MsgBox("Windowsを強制的に再起動します。開かれている全てのプログラムは閉じられ、保存されていないデータは失われます。続行しますか？", MsgBoxStyle.YesNo Or MsgBoxStyle.Question, "") = MsgBoxResult.Yes Then

                prepareToExitFromWindows()
                ExitWindowsEx(ExitWindows.EWX_REBOOT Or ExitWindows.EWX_FORCE, 0)

            Else

                Exit Sub

            End If

        Else

            prepareToExitFromWindows()
            ExitWindowsEx(ExitWindows.EWX_REBOOT, 0)

        End If

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Me.Close()

    End Sub

End Class
